<?php
	$i = 0;
	
	$cfg[$i]['name'] = "Options";
	$cfg[$i]['type'] = "header";
	$cfg[$i]['options'] = "";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "";
	
	$i++;
	$cfg[$i]['name'] = "allow_anon_ssl";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "Only applies if ssl_enable is active. If set to YES, anonymous users will be allowed to use secured SSL connections.";
	
	$i++;
	$cfg[$i]['name'] = "anon_mkdir_write_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If set to YES, anonymous users will be permitted to create new directories under certain conditions. For this to work, the option write_enable must be activated, and the anonymous ftp user must have write permission on the parent directory. ";
	
	$i++;
	$cfg[$i]['name'] = "anon_other_write_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If set to YES, anonymous users will be permitted to perform write operations other than upload and create directory, such as deletion and renaming. This is generally not recommended but included for completeness. ";
	
	$i++;
	$cfg[$i]['name'] = "anon_upload_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If set to YES, anonymous users will be permitted to upload files under certain conditions. For this to work, the option write_enable must be activated, and the anonymous ftp user must have write permission on desired upload locations. ";
	
	$i++;
	$cfg[$i]['name'] = "anon_world_readable_only";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "YES";
	$cfg[$i]['help'] = "When enabled, anonymous users will only be allowed to download files which are world readable. This is recognising that the ftp user may own files, especially in the presence of uploads. ";
	
	$i++;
	$cfg[$i]['name'] = "anonymous_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "Controls whether anonymous logins are permitted or not. If enabled, both the usernames ftp and anonymous are recognised as anonymous logins. ";
	
	$i++;
	$cfg[$i]['name'] = "ascii_download_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "When enabled, ASCII mode data transfers will be honoured on downloads. ";
	
	$i++;
	$cfg[$i]['name'] = "ascii_upload_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "When enabled, ASCII mode data transfers will be honoured on uploads. ";
	
	$i++;
	$cfg[$i]['name'] = "async_abor_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "When enabled, a special FTP command known as 'async ABOR' will be enabled. Only ill advised FTP clients will use this feature. Additionally, this feature is awkward to handle, so it is disabled by default. Unfortunately, some FTP clients will hang when cancelling a transfer unless this feature is available, so you may wish to enable it. ";
	
	$i++;
	$cfg[$i]['name'] = "background";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "When enabled, and vsftpd is started in 'listen' mode, vsftpd will background the listener process. i.e. control will immediately be returned to the shell which launched vsftpd. ";
	
	$i++;
	$cfg[$i]['name'] = "check_shell";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "YES";
	$cfg[$i]['help'] = "Note! This option only has an effect for non-PAM builds of vsftpd. If disabled, vsftpd will not check /etc/shells for a valid user shell for local logins. ";
	
	$i++;
	$cfg[$i]['name'] = "chmod_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "YES";
	$cfg[$i]['help'] = "When enables, allows use of the SITE CHMOD command. NOTE! This only applies to local users. Anonymous users never get to use SITE CHMOD. ";
	
	$i++;
	$cfg[$i]['name'] = "chown_uploads";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, all anonymously uploaded files will have the ownership changed to the user specified in the setting chown_username. This is useful from an administrative, and perhaps security, standpoint. ";
	
	$i++;
	$cfg[$i]['name'] = "chroot_list_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If activated, you may provide a list of local users who are placed in a chroot() jail in their home directory upon login. The meaning is slightly different if chroot_local_user is set to YES. In this case, the list becomes a list of users which are NOT to be placed in a chroot() jail. By default, the file containing this list is /etc/vsftpd.chroot_list, but you may override this with the chroot_list_file setting. ";
	
	$i++;
	$cfg[$i]['name'] = "chroot_local_user";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If set to YES, local users will be (by default) placed in a chroot() jail in their home directory after login. Warning: This option has security implications, especially if the users have upload permission, or shell access. Only enable if you know what you are doing. Note that these security implications are not vsftpd specific. They apply to all FTP daemons which offer to put local users in chroot() jails. ";
	
	$i++;
	$cfg[$i]['name'] = "connect_from_port_20";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "This controls whether PORT style data connections use port 20 (ftp-data) on the server machine. For security reasons, some clients may insist that this is the case. Conversely, disabling this option enables vsftpd to run with slightly less privilege. ";
	
	$i++;
	$cfg[$i]['name'] = "deny_email_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If activated, you may provide a list of anonymous password e-mail responses which cause login to be denied. By default, the file containing this list is /etc/vsftpd.banned_emails, but you may override this with the banned_email_file setting. ";
	
	$i++;
	$cfg[$i]['name'] = "dirlist_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "YES";
	$cfg[$i]['help'] = "If set to NO, all directory list commands will give permission denied. ";
	
	$i++;
	$cfg[$i]['name'] = "dirmessage_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, users of the FTP server can be shown messages when they first enter a new directory. By default, a directory is scanned for the file .message, but that may be overridden with the configuration setting message_file. ";
	
	$i++;
	$cfg[$i]['name'] = "download_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "YES";
	$cfg[$i]['help'] = "If set to NO, all download requests will give permission denied. ";
	
	$i++;
	$cfg[$i]['name'] = "dual_log_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, two log files are generated in parallel, going by default to /var/log/xferlog and /var/log/vsftpd.log. The former is a wu-ftpd style transfer log, parseable by standard tools. The latter is vsftpd's own style log. ";
	
	$i++;
	$cfg[$i]['name'] = "force_dot_files";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If activated, files and directories starting with . will be shown in directory listings even if the 'a' flag was not used by the client. This override excludes the '.' and '..' entries. ";
	
	$i++;
	$cfg[$i]['name'] = "force_local_data_ssl";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "YES";
	$cfg[$i]['help'] = "Only applies if ssl_enable is activated. If activated, all non-anonymous logins are forced to use a secure SSL connection in order to send and receive data on data connections. ";
	
	$i++;
	$cfg[$i]['name'] = "force_local_logins_ssl";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "YES";
	$cfg[$i]['help'] = "Only applies if ssl_enable is activated. If activated, all non-anonymous logins are forced to use a secure SSL connection in order to send the password. ";
	
	$i++;
	$cfg[$i]['name'] = "guest_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, all non-anonymous logins are classed as 'guest' logins. A guest login is remapped to the user specified in the guest_username setting. ";
	
	$i++;
	$cfg[$i]['name'] = "hide_ids";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, all user and group information in directory listings will be displayed as 'ftp'. ";
	
	$i++;
	$cfg[$i]['name'] = "listen";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, vsftpd will run in standalone mode. This means that vsftpd must not be run from an inetd of some kind. Instead, the vsftpd executable is run once directly. vsftpd itself will then take care of listening for and handling incoming connections. ";
	
	$i++;
	$cfg[$i]['name'] = "listen_ipv6";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "Like the listen parameter, except vsftpd will listen on an IPv6 socket instead of an IPv4 one. This parameter and the listen parameter are mutually exclusive. ";
	
	$i++;
	$cfg[$i]['name'] = "local_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "Controls whether local logins are permitted or not. If enabled, normal user accounts in /etc/passwd may be used to log in. ";
	
	$i++;
	$cfg[$i]['name'] = "log_ftp_protocol";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "When enabled, all FTP requests and responses are logged, providing the option xferlog_std_format is not enabled. Useful for debugging. ";
	
	$i++;
	$cfg[$i]['name'] = "ls_recurse_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "When enabled, this setting will allow the use of 'ls -R'. This is a minor security risk, because a ls -R at the top level of a large site may consume a lot of resources. ";
	
	$i++;
	$cfg[$i]['name'] = "no_anon_password";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "When enabled, this prevents vsftpd from asking for an anonymous password - the anonymous user will log straight in. ";
	
	$i++;
	$cfg[$i]['name'] = "no_log_lock";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "When enabled, this prevents vsftpd from taking a file lock when writing to log files. This option should generally not be enabled. It exists to workaround operating system bugs such as the Solaris / Veritas filesystem combination which has been observed to sometimes exhibit hangs trying to lock log files. ";
	
	$i++;
	$cfg[$i]['name'] = "one_process_model";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If you have a Linux 2.4 kernel, it is possible to use a different security model which only uses one process per connection. It is a less pure security model, but gains you performance. You really don't want to enable this unless you know what you are doing, and your site supports huge numbers of simultaneously connected users. ";
	
	$i++;
	$cfg[$i]['name'] = "passwd_chroot_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, along with chroot_local_user , then a chroot() jail location may be specified on a per-user basis. Each user's jail is derived from their home directory string in /etc/passwd. The occurrence of /./ in the home directory string denotes that the jail is at that particular location in the path. ";
	
	$i++;
	$cfg[$i]['name'] = "pasv_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "YES";
	$cfg[$i]['help'] = "Set to NO if you want to disallow the PASV method of obtaining a data connection. ";
	
	$i++;
	$cfg[$i]['name'] = "pasv_promiscuous";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "Set to YES if you want to disable the PASV security check that ensures the data connection originates from the same IP address as the control connection. Only enable if you know what you are doing! The only legitimate use for this is in some form of secure tunnelling scheme, or perhaps to facilitate FXP support. ";
	
	$i++;
	$cfg[$i]['name'] = "port_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "YES";
	$cfg[$i]['help'] = "Set to NO if you want to disallow the PORT method of obtaining a data connection. ";
	
	$i++;
	$cfg[$i]['name'] = "port_promiscuous";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "Set to YES if you want to disable the PORT security check that ensures that outgoing data connections can only connect to the client. Only enable if you know what you are doing! ";
	
	$i++;
	$cfg[$i]['name'] = "run_as_launching_user";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "Set to YES if you want vsftpd to run as the user which launched vsftpd. This is useful where root access is not available. MASSIVE WARNING! Do NOT enable this option unless you totally know what you are doing, as naive use of this option can create massive security problems. Specifically, vsftpd does not / cannot use chroot technology to restrict file access when this option is set (even if launched by root). A poor substitute could be to use a deny_file setting such as {/*,*..*}, but the reliability of this cannot compare to chroot, and should not be relied on. If using this option, many restrictions on other options apply. For example, options requiring privilege such as non-anonymous logins, upload ownership changing, connecting from port 20 and listen ports less than 1024 are not expected to work. Other options may be impacted. ";
	
	$i++;
	$cfg[$i]['name'] = "secure_email_list_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "Set to YES if you want only a specified list of e-mail passwords for anonymous logins to be accepted. This is useful as a low-hassle way of restricting access to low-security content without needing virtual users. When enabled, anonymous logins are prevented unless the password provided is listed in the file specified by the email_password_file setting. The file format is one password per line, no extra whitespace. The default filename is /etc/vsftpd.email_passwords. ";
	
	$i++;
	$cfg[$i]['name'] = "session_support";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "This controls whether vsftpd attempts to maintain sessions for logins. If vsftpd is maintaining sessions, it will try and update utmp and wtmp. It will also open a pam_session if using PAM to authenticate, and only close this upon logout. You may wish to disable this if you do not need session logging, and you wish to give vsftpd more opportunity to run with less processes and / or less privilege. NOTE - utmp and wtmp support is only provided with PAM enabled builds. ";
	
	$i++;
	$cfg[$i]['name'] = "setproctitle_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, vsftpd will try and show session status information in the system process listing. In other words, the reported name of the process will change to reflect what a vsftpd session is doing (idle, downloading etc). You probably want to leave this off for security purposes. ";
	
	$i++;
	$cfg[$i]['name'] = "ssl_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, and vsftpd was compiled against OpenSSL, vsftpd will support secure connections via SSL. This applies to the control connection (including login) and also data connections. You'll need a client with SSL support too. NOTE!! Beware enabling this option. Only enable it if you need it. vsftpd can make no guarantees about the security of the OpenSSL libraries. By enabling this option, you are declaring that you trust the security of your installed OpenSSL library. ";
	
	$i++;
	$cfg[$i]['name'] = "ssl_sslv2";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "Only applies if ssl_enable is activated. If enabled, this option will permit SSL v2 protocol connections. TLS v1 connections are preferred. ";
	
	$i++;
	$cfg[$i]['name'] = "ssl_sslv3";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "Only applies if ssl_enable is activated. If enabled, this option will permit SSL v3 protocol connections. TLS v1 connections are preferred. ";
	
	$i++;
	$cfg[$i]['name'] = "ssl_tlsv1";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "YES";
	$cfg[$i]['help'] = "Only applies if ssl_enable is activated. If enabled, this option will permit TLS v1 protocol connections. TLS v1 connections are preferred. ";
	
	$i++;
	$cfg[$i]['name'] = "syslog_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, then any log output which would have gone to /var/log/vsftpd.log goes to the system log instead. Logging is done under the FTPD facility. ";
	
	$i++;
	$cfg[$i]['name'] = "tcp_wrappers";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, and vsftpd was compiled with tcp_wrappers support, incoming connections will be fed through tcp_wrappers access control. Furthermore, there is a mechanism for per-IP based configuration. If tcp_wrappers sets the VSFTPD_LOAD_CONF environment variable, then the vsftpd session will try and load the vsftpd configuration file specified in this variable. ";
	
	$i++;
	$cfg[$i]['name'] = "text_userdb_names";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "By default, numeric IDs are shown in the user and group fields of directory listings. You can get textual names by enabling this parameter. It is off by default for performance reasons. ";
	
	$i++;
	$cfg[$i]['name'] = "tilde_user_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, vsftpd will try and resolve pathnames such as ~chris/pics, i.e. a tilde followed by a username. Note that vsftpd will always resolve the pathnames ~ and ~/something (in this case the ~ resolves to the initial login directory). Note that ~user paths will only resolve if the file /etc/passwd may be found within the _current_ chroot() jail. ";
	
	$i++;
	$cfg[$i]['name'] = "use_localtime";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, vsftpd will display directory listings with the time in your local time zone. The default is to display GMT. The times returned by the MDTM FTP command are also affected by this option. ";
	
	$i++;
	$cfg[$i]['name'] = "use_sendfile";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "YES";
	$cfg[$i]['help'] = "An internal setting used for testing the relative benefit of using the sendfile() system call on your platform. ";
	
	$i++;
	$cfg[$i]['name'] = "userlist_deny";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "YES";
	$cfg[$i]['help'] = "This option is examined if userlist_enable is activated. If you set this setting to NO, then users will be denied login unless they are explicitly listed in the file specified by userlist_file. When login is denied, the denial is issued before the user is asked for a password. ";
	
	$i++;
	$cfg[$i]['name'] = "userlist_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, vsftpd will load a list of usernames, from the filename given by userlist_file. If a user tries to log in using a name in this file, they will be denied before they are asked for a password. This may be useful in preventing cleartext passwords being transmitted. See also userlist_deny. ";
	
	$i++;
	$cfg[$i]['name'] = "virtual_use_local_privs";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, virtual users will use the same privileges as local users. By default, virtual users will use the same privileges as anonymous users, which tends to be more restrictive (especially in terms of write access). ";
	
	$i++;
	$cfg[$i]['name'] = "write_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "This controls whether any FTP commands which change the filesystem are allowed or not. These commands are: STOR, DELE, RNFR, RNTO, MKD, RMD, APPE and SITE. ";
	
	$i++;
	$cfg[$i]['name'] = "xferlog_enable";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, a log file will be maintained detailling uploads and downloads. By default, this file will be placed at /var/log/vsftpd.log, but this location may be overridden using the configuration setting vsftpd_log_file. ";
	
	$i++;
	$cfg[$i]['name'] = "xferlog_std_format";
	$cfg[$i]['type'] = "checkbox";
	$cfg[$i]['options'] = "YES:NO";
	$cfg[$i]['default'] = "NO";
	$cfg[$i]['help'] = "If enabled, the transfer log file will be written in standard xferlog format, as used by wu-ftpd. This is useful because you can reuse existing transfer statistics generators. The default format is more readable, however. The default location for this style of log file is /var/log/xferlog, but you may change it with the setting xferlog_file. ";
	
	$i++;
	$cfg[$i]['name'] = "Numeric Options";
	$cfg[$i]['type'] = "header";
	$cfg[$i]['options'] = "";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "";
	
	$i++;
	$cfg[$i]['name'] = "accept_timeout";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "60";
	$cfg[$i]['help'] = "The timeout, in seconds, for a remote client to establish connection with a PASV style data connection. ";
	
	$i++;
	$cfg[$i]['name'] = "anon_max_rate";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "0";
	$cfg[$i]['help'] = "The maximum data transfer rate permitted, in bytes per second, for anonymous clients. ";
	
	$i++;
	$cfg[$i]['name'] = "anon_umask";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "077";
	$cfg[$i]['help'] = "The value that the umask for file creation is set to for anonymous users. NOTE! If you want to specify octal values, remember the '0' prefix otherwise the value will be treated as a base 10 integer! ";
	
	$i++;
	$cfg[$i]['name'] = "connect_timeout";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "60";
	$cfg[$i]['help'] = "The timeout, in seconds, for a remote client to respond to our PORT style data connection. ";
	
	$i++;
	$cfg[$i]['name'] = "data_connection_timeout";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "300";
	$cfg[$i]['help'] = "The timeout, in seconds, which is roughly the maximum time we permit data transfers to stall for with no progress. If the timeout triggers, the remote client is kicked off. ";
	
	$i++;
	$cfg[$i]['name'] = "file_open_mode";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "0666";
	$cfg[$i]['help'] = "The permissions with which uploaded files are created. Umasks are applied on top of this value. You may wish to change to 0777 if you want uploaded files to be executable. ";
	
	$i++;
	$cfg[$i]['name'] = "ftp_data_port";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "20";
	$cfg[$i]['help'] = "The port from which PORT style connections originate (as long as the poorly named connect_from_port_20 is enabled). ";
	
	$i++;
	$cfg[$i]['name'] = "idle_session_timeout";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "300";
	$cfg[$i]['help'] = "The timeout, in seconds, which is the maximum time a remote client may spend between FTP commands. If the timeout triggers, the remote client is kicked off. ";
	
	$i++;
	$cfg[$i]['name'] = "listen_port";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "21";
	$cfg[$i]['help'] = "If vsftpd is in standalone mode, this is the port it will listen on for incoming FTP connections. ";
	
	$i++;
	$cfg[$i]['name'] = "local_max_rate";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "0";
	$cfg[$i]['help'] = "The maximum data transfer rate permitted, in bytes per second, for local authenticated users. ";
	
	$i++;
	$cfg[$i]['name'] = "local_umask";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "077";
	$cfg[$i]['help'] = "The value that the umask for file creation is set to for local users. NOTE! If you want to specify octal values, remember the '0' prefix otherwise the value will be treated as a base 10 integer! ";
	
	$i++;
	$cfg[$i]['name'] = "max_clients";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "0";
	$cfg[$i]['help'] = "If vsftpd is in standalone mode, this is the maximum number of clients which may be connected. Any additional clients connecting will get an error message. ";
	
	$i++;
	$cfg[$i]['name'] = "max_per_ip";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "0";
	$cfg[$i]['help'] = "If vsftpd is in standalone mode, this is the maximum number of clients which may be connected from the same source internet address. A client will get an error message if they go over this limit. ";
	
	$i++;
	$cfg[$i]['name'] = "pasv_max_port";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "0";
	$cfg[$i]['help'] = "The maximum port to allocate for PASV style data connections. Can be used to specify a narrow port range to assist firewalling. ";
	
	$i++;
	$cfg[$i]['name'] = "pasv_min_port";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "0";
	$cfg[$i]['help'] = "The minimum port to allocate for PASV style data connections. Can be used to specify a narrow port range to assist firewalling. ";
	
	$i++;
	$cfg[$i]['name'] = "trans_chunk_size";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=5";
	$cfg[$i]['default'] = "0";
	$cfg[$i]['help'] = "You probably don't want to change this, but try setting it to something like 8192 for a much smoother bandwidth limiter. ";
	
	$i++;
	$cfg[$i]['name'] = "Text based options";
	$cfg[$i]['type'] = "header";
	$cfg[$i]['options'] = "";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "";
	
	$i++;
	$cfg[$i]['name'] = "anon_root";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "This option represents a directory which vsftpd will try to change into after an anonymous login. Failure is silently ignored. ";
	
	$i++;
	$cfg[$i]['name'] = "banned_email_file";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "/etc/vsftpd.banned_emails";
	$cfg[$i]['help'] = "This option is the name of a file containing a list of anonymous e-mail passwords which are not permitted. This file is consulted if the option deny_email_enable is enabled. ";
	
	$i++;
	$cfg[$i]['name'] = "banner_file";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "This option is the name of a file containing text to display when someone connects to the server. If set, it overrides the banner string provided by the ftpd_banner option. ";
	
	$i++;
	$cfg[$i]['name'] = "chown_username";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "root";
	$cfg[$i]['help'] = "This is the name of the user who is given ownership of anonymously uploaded files. This option is only relevant if another option, chown_uploads, is set. ";
	
	$i++;
	$cfg[$i]['name'] = "Dchroot_list_file";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "/etc/vsftpd.chroot_list";
	$cfg[$i]['help'] = "The option is the name of a file containing a list of local users which will be placed in a chroot() jail in their home directory. This option is only relevant if the option chroot_list_enable is enabled. If the option chroot_local_user is enabled, then the list file becomes a list of users to NOT place in a chroot() jail. ";
	
	$i++;
	$cfg[$i]['name'] = "cmds_allowed";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "This options specifies a comma separated list of allowed FTP commands (post login. USER, PASS and QUIT are always allowed pre-login). Other commands are rejected. This is a powerful method of really locking down an FTP server. Example: cmds_allowed=PASV,RETR,QUIT ";
	
	$i++;
	$cfg[$i]['name'] = "deny_file";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "This option can be used to set a pattern for filenames (and directory names etc.) which should not be accessible in any way. The affected items are not hidden, but any attempt to do anything to them (download, change into directory, affect something within directory etc.) will be denied. This option is very simple, and should not be used for serious access control - the filesystem's permissions should be used in preference. Example: deny_file={*.mp3,*.mov,.private} ";
	
	$i++;
	$cfg[$i]['name'] = "dsa_cert_file";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "This option specifies the location of the DSA certificate to use for SSL encrypted connections. ";
	
	$i++;
	$cfg[$i]['name'] = "email_password_file";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "/etc/vsftpd.email_passwords";
	$cfg[$i]['help'] = "This option can be used to provide an alternate file for usage by the secure_email_list_enable setting. ";
	
	$i++;
	$cfg[$i]['name'] = "ftp_username";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "ftp";
	$cfg[$i]['help'] = "This is the name of the user we use for handling anonymous FTP. The home directory of this user is the root of the anonymous FTP area. ";
	
	$i++;
	$cfg[$i]['name'] = "ftpd_banner";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "This string option allows you to override the greeting banner displayed by vsftpd when a connection first comes in. ";
	
	$i++;
	$cfg[$i]['name'] = "guest_username";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "ftp";
	$cfg[$i]['help'] = "See the boolean setting guest_enable for a description of what constitutes a guest login. This setting is the real username which guest users are mapped to. ";
	
	$i++;
	$cfg[$i]['name'] = "hide_file";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "This option can be used to set a pattern for filenames (and directory names etc.) which should be hidden from directory listings. Despite being hidden, the files / directories etc. are fully accessible to clients who know what names to actually use. Items will be hidden if their names contain the string given by hide_file, or if they match the regular expression specified by hide_file. Note that vsftpd's regular expression matching code is a simple implementation which is a subset of full regular expression functionality. Example: hide_file={*.mp3,.hidden,hide*,h?} ";
	
	$i++;
	$cfg[$i]['name'] = "listen_address";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "If vsftpd is in standalone mode, the default listen address (of all local interfaces) may be overridden by this setting. Provide a numeric IP address. ";
	
	$i++;
	$cfg[$i]['name'] = "listen_address6";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "Like listen_address, but specifies a default listen address for the IPv6 listener (which is used if listen_ipv6 is set). Format is standard IPv6 address format. ";
	
	$i++;
	$cfg[$i]['name'] = "local_root";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "This option represents a directory which vsftpd will try to change into after a local (i.e. non-anonymous) login. Failure is silently ignored. ";
	
	$i++;
	$cfg[$i]['name'] = "message_file";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = ".message";
	$cfg[$i]['help'] = "This option is the name of the file we look for when a new directory is entered. The contents are displayed to the remote user. This option is only relevant if the option dirmessage_enable is enabled. ";
	
	$i++;
	$cfg[$i]['name'] = "nopriv_user";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "nobody";
	$cfg[$i]['help'] = "This is the name of the user that is used by vsftpd when it wants to be totally unprivileged. Note that this should be a dedicated user, rather than nobody. The user nobody tends to be used for rather a lot of important things on most machines. ";
	
	$i++;
	$cfg[$i]['name'] = "pam_service_name";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "ftp";
	$cfg[$i]['help'] = "This string is the name of the PAM service vsftpd will use. ";
	
	$i++;
	$cfg[$i]['name'] = "pasv_address";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "Use this option to override the IP address that vsftpd will advertise in response to the PASV command. Provide a numeric IP address. ";
	
	$i++;
	$cfg[$i]['name'] = "rsa_cert_file";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "/usr/share/ssl/certs/vsftpd.pem";
	$cfg[$i]['help'] = "This option specifies the location of the RSA certificate to use for SSL encrypted connections. ";
	
	$i++;
	$cfg[$i]['name'] = "secure_chroot_dir";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "/usr/share/empty";
	$cfg[$i]['help'] = "This option should be the name of a directory which is empty. Also, the directory should not be writable by the ftp user. This directory is used as a secure chroot() jail at times vsftpd does not require filesystem access. ";
	
	$i++;
	$cfg[$i]['name'] = "ssl_ciphers";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "DES-CBC3-SHA";
	$cfg[$i]['help'] = "This option can be used to select which SSL ciphers vsftpd will allow for encrpyted SSL connections. See the ciphers man page for further details. Note that restricting ciphers can be a useful security precaution as it prevents malicious remote parties forcing a cipher which they have found problems with. ";
	
	$i++;
	$cfg[$i]['name'] = "user_config_dir";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "This powerful option allows the override of any config option specified in the manual page, on a per-user basis. Usage is simple, and is best illustrated with an example. If you set user_config_dir to be /etc/vsftpd_user_conf and then log on as the user 'chris', then vsftpd will apply the settings in the file /etc/vsftpd_user_conf/chris for the duration of the session. The format of this file is as detailed in this manual page! PLEASE NOTE that not all settings are effective on a per-user basis. For example, many settings only prior to the user's session being started. Examples of settings which will not affect any behviour on a per-user basis include listen_address, banner_file, max_per_ip, max_clients, xferlog_file, etc. ";
	
	$i++;
	$cfg[$i]['name'] = "user_sub_token";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "";
	$cfg[$i]['help'] = "This option is useful is conjunction with virtual users. It is used to automatically generate a home directory for each virtual user, based on a template. For example, if the home directory of the real user specified via guest_username is /home/virtual/\$USER, and user_sub_token is set to \$USER, then when virtual user fred logs in, he will end up (usually chroot()'ed) in the directory /home/virtual/fred. This option also takes affect if local_root contains user_sub_token. ";
	
	$i++;
	$cfg[$i]['name'] = "userlist_file";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "/etc/vsftpd.user_list";
	$cfg[$i]['help'] = "This option is the name of the file loaded when the userlist_enable option is active. ";
	
	$i++;
	$cfg[$i]['name'] = "vsftpd_log_file";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "/var/log/vsftpd.log";
	$cfg[$i]['help'] = "This option is the name of the file to which we write the vsftpd style log file. This log is only written if the option xferlog_enable is set, and xferlog_std_format is NOT set. Alternatively, it is written if you have set the option dual_log_enable. One further complication - if you have set syslog_enable, then this file is not written and output is sent to the system log instead. ";
	
	$i++;
	$cfg[$i]['name'] = "xferlog_file";
	$cfg[$i]['type'] = "text";
	$cfg[$i]['options'] = "size=30";
	$cfg[$i]['default'] = "/var/log/xferlog";
	$cfg[$i]['help'] = "This option is the name of the file to which we write the wu-ftpd style transfer log. The transfer log is only written if the option xferlog_enable is set, along with xferlog_std_format. Alternatively, it is written if you have set the option dual_log_enable. ";

?>