<?php

include_once("form.class.php");

class FormList extends Form {	
	
	function setConfigpath($path) {
		Form::setConfigpath($path);
	}
	
	function loadSettings($file) {
		Form::loadSettings($file);
	}
	
	function loadConfig() {
		Form::loadConfig($file);
	}

	// The user performed some POST or GET action. This function will relay that to the plugin
	function Execute($args) {
		$current = $this->_settings;
		if ($args['action'] == "Finish") {
			// Update the setting list with the new values
			for ($i = 0; $i < count($current); $i++) {
    			if (array_key_exists($current[$i]['name'], $args)) {
    				$new_item = $args[$current[$i]['name']];
        			if (isset($current[$i]['current'])) {
        				if (!(strcmp($current[$i]['current'], $new_item) == 0)) {
	        				// setting also is a script arguement
	        				$current[$i]['current'] = $new_item;
	        			}
        			} else {
    					$current[$i]['current'] = $new_item;
    				}
    			} else {
    				// The option isn't in the arguements -> the option is off
    				$current[$i]['current'] = $current[$i]['default'];
    			}
	        }
			$this->_settings = $current;
		        
			// Save the current settings to the configuration file
			$this->SaveConfig();
		}
		$this->Show();
	}
	
	/* 
	 * Private functions 
	 */
	 
	function Show()
	{
		for ($i = 0; $i < count($this->_settings); $i++) {
			if (isset($this->_settings[$i]['type'])) {
				switch ($this->_settings[$i]['type']) {
					case "header":
						$this->ShowHeader($this->_settings[$i]);
						break;
					case "radio":
						$this->ShowRadio($this->_settings[$i]);
						break;
					case "checkbox":
						$this->ShowCheckbox($this->_settings[$i]);
						break;
					case "text":
						$this->ShowText($this->_settings[$i]);
						break;
					case "submit":
						$this->ShowSubmit($this->_settings[$i]);
						break;
				}
			}
		}
		// Add the default Finish and Cancel buttons
		$this->ShowFinishCancel();
	}
	
	// Save the arguements from the webinterface to the config file
	function SaveConfig() {
		$FileName = $this->_configpath;
		echo $FileName;
		$wt_res = wt_init_cfg_file($FileName);
	    if ($wt_res == "OK") {
	        if (!($wt_file_handle = @fopen($FileName, "w"))) {
	            wt_error("could not write ".$FileName." file");
	            return false;
	        }
	        // The for loop below should have a 'for each' construction
	        for ($i = 0; $i < count($this->_settings); $i++) {
	        	switch ($this->_settings[$i]['type']) {
	        		case "radio":
	        		case "checkbox":
	        		case "text":
	        			fwrite($wt_file_handle, $this->_settings[$i]['name'] . "=");
	                	fwrite($wt_file_handle, $this->_settings[$i]['current'] . "\n");
	                	break;
	            }
	        }
	        fclose($wt_file_handle);
	    } else {
	        wt_error($wt_res);
	        return false;
	    }
	    return;
	}
	
	function ShowHeader($cfg) {
		echo "\n<table >";
		echo "\n\t<tr>";
		echo "\n\t\t<td class=\"top\" colspan=\"185%\" align=\"center\">" . $cfg['name'] . "</td>";
		echo "\n\t</tr>";
		echo "\n</table>";
	}
	
	function ShowRadio($cfg) {
		echo "\n<fieldset>";
		echo "\n<legend><font size=1><b>" . $cfg['name'] . "</b></font></legend>";
		echo "\n<table>";
		
		// Default value
		if (!isset($cfg['default']) || $cfg['default'] == "") {
			$default = "<i>empty</i>";
		} else {
			$default = $cfg['default'];
		}
		echo "\n\t<tr>\n\t\t<td class=\"line2\">Default: " . $default . "</td>";
		
		// Help 
		$parts = split(":", $cfg['options']);
		$columns = count($parts) + 1;
		if (!isset($cfg['help']) || $cfg['help'] == "") {
			echo "\n\t\t<td class=\"line\" rowspan=\"" . $columns . "\"><i>No help available</i></td>";
		} else {
			echo "\n\t\t<td class=\"line\" rowspan=\"" . $columns . "\">" . $cfg['help'] . "</td>";
		}
		echo "\n\t</tr>";
		
		// Radio buttons
		for ($i = 0; $i < count($parts); $i++) {
			if (!isset($cfg['current']) || $cfg['current'] == "") {
				die();
				if ($parts[$i] == $cfg['default']) {
					$checked = "checked";
				} else {
					$checked = "";
				}
			} else {
				if ($parts[$i] == $cfg['current']) {
					$checked = "checked";
				} else {
					$checked = "";
				}
			}
			echo "\n\t<tr>";
			echo "\n\t\t<td class=\"line2\" width=\"90px\" align=\"right\">" . $parts[$i];
			echo "<input class=\"radio\" type=\"radio\" align=\"right\" name=\"" . $cfg['name'] . "\" " . $checked . " value=\"" . $parts[$i] . "\">";
			echo "</td>";
			echo "\n\t</tr>";
		}
		echo "\n</table>";
		echo "\n</fieldset>";
	}

	function ShowCheckbox($cfg) {
		echo "\n<fieldset>";
		echo "\n<legend><font size=1><b>" . $cfg['name'] . "</b></font></legend>";
		echo "\n<table>\n\t<tr>";
		
		// Default value
		if (!isset($cfg['default']) || $cfg['default'] == "") {
			$default = "<i>empty</i>";
		} else {
			$default = $cfg['default'];
		}
		echo "\n\t\t<td class=\"line2\">Default: " . $default . "</td>";
		
		// Help 
		$parts = split(":", $cfg['options']);
		$columns = count($parts) + 1;
		if (!isset($cfg['help']) || $cfg['help'] == "") {
			echo "\n\t\t<td class=\"line\" rowspan=\"" . $columns . "\"><i>No help available</i></td>";
		} else {
			echo "\n\t\t<td class=\"line\" rowspan=\"" . $columns . "\">" . $cfg['help'] . "</td>";
		}
		echo "\n\t</tr>";
		$options = strtolower($cfg['options']);
		if (count($parts) == 2 
			&& ($options == "on:off" 
				|| $options == "off:on" 
				|| $options == "yes:no" 
				|| $options == "no:yes" 
				|| $options == "0:1" 
				|| $options == "1:0")) {
			// This type uses only one checkbox
			if (!isset($cfg['current']) || $cfg['current'] == "") {
				// Current value is not known -> strange for a 2 option checkbox
				// Give the setting its default value
				$current = $cfg['default'];
				//Checkbox
				if ($parts[0] == $current) {
					$checked = "checked";
				} else {
					$checked = "";
				}
			} else {
				$current = $cfg['current'];
				
				//Checkbox
				if ($parts[0] == $current) {
					$checked = "checked";
				} else {
					$checked = "";
				}
			}
			echo "\n\t<tr>\n\t\t<td align=\"left\" width=\"90px\">";
			echo " <input type=\"checkbox\" name=\"" . $cfg['name'] . "\" " . $checked . " value=\"" . $parts[0] . "\">";
			echo "</td>\n\t</tr>";					
		} else {
			// This type uses more then one checkbox
			for ($i = 0; $i < count($parts); $i++) {
				if ($parts[$i] == $cfg['current']) {
					$checked = "checked";
				} else {
					$checked = "";
				}
				echo "\n\t<tr>\n\t\t<td class=\"line2\" align=\"left\" width=\"90px\">";
				echo " <input type=\"checkbox\" align=\"left\" name=\"" . $cfg['name'] . "\" " . $checked . " value=\"" . $parts[0] . "\">";
				echo $parts[$i];
				echo "</td>\n\t</tr>";
			}
		}
		echo "\n</table>";
		echo "\n</fieldset>";
	}
	
	function ShowText($cfg) {
		echo "\n<fieldset>";
		echo "\n<legend><font size=1><b>" . $cfg['name'] . "</b></font></legend>";
		echo "\n<table>";
		// Value
		$parts = split(":", $cfg['options']);
		if (isset($cfg['current'])) {
			$value = $cfg['current'];
		} else {
			$value = $cfg['default'];
		}
		//Default
		if (!isset($cfg['default']) || $cfg['default'] == "") {
			$default = "<i>empty</i>";
		} else {
			$default = $cfg['default'];
		}
		echo "\n\t<tr>\n\t\t<td class=\"line2\">Default: " . $default . "</td>";
		if (!isset($cfg['help']) || $cfg['help'] == "") {
			echo "<td class=\"line\"><i>No help available</i></td>";
		} else {
			echo "\n\t\t<td class=\"line1\" rowspan=\"2\">" . $cfg['help'] . "</td>\n\t</tr>";
		}
		echo "\n\t<tr>\n\t\t<td class=\"line2\"><input type=\"text\" align=\"left\" name=\"" . $cfg['name'] . "\" " . $cfg['options'] . " value=\"" . $value . "\"></td>\n\t</tr>";

		echo "\n</table>";
		echo "\n</fieldset>";
	}
	
	function ShowSubmit($cfg) {
		
	}
	
	function ShowFinishCancel() {
		echo "\n<table>\n\t<tr>";
    	echo "\n\t\t<td class=\"line\">";
    	echo "<input type=\"submit\" name=\"action\" value=\"Finish\" class=\"submit\">";
    	echo "</td>";
    	echo "\n\t\t<td class=\"line\">";
    	echo "<input type=reset name=\"submit\" value=\"Cancel\" class=\"submit\">";
    	echo "</td>";
    	echo "\n\t</tr>\n</table>";
	}
};

?>