<?php
/*****************************************************************************
 * Web Tools (WT) - 0.2 - a collection of web hosting tools                  *
 * Copyright (C) 2000-2004 Colin Verot - colin@verot.net                     *
 * Copyright (C) 2005 Lambertus IJsselstein - webtools@lijsselstein.demon.nl *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify      *
 * it under the terms of the GNU General Public License as published by      *
 * the Free Software Foundation; either version 2 of the License, or         *
 * (at your option) any later version.                                       *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * General Public License for more details.                                  *
 *                                                                           *
 * You should have received a copy of the GNU General Public License         *
 * along with this program; if not, write to the                             *
 *    Free Software Foundation, Inc.                                         *
 *    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 *****************************************************************************/

require_once('core.wt.php');
require_once('config.inc.php');

if (strlen($_SERVER['SCRIPT_FILENAME']) == 0) {
	$wt_root_path = "";
} else {
	$wt_root_path = ereg_replace("(.*)/([^/]*)", "\\1", $_SERVER['SCRIPT_FILENAME']) . "/";
}

// read the plugins parameters from wt.cfg
$wt_cfg_config_file = $wt_cfg_main_config_file;
$wt_cfg_plugin = array();
$wt_cfg_order = array();
wt_read_cfg_file();
for ($wt_cpt = 0; $wt_cpt < count($wt_cfg_item); $wt_cpt++) {
    if (!empty($wt_cfg_item[$wt_cpt])) {
        $wt_tmp = explode("|", $wt_cfg_item[$wt_cpt]);
        $wt_cfg_plugin[$wt_cpt]["plugin"]     = $wt_tmp[0];
        $wt_cfg_plugin[$wt_cpt]["label"]      = $wt_tmp[1];
        $wt_cfg_plugin[$wt_cpt]["title"]      = $wt_tmp[2];
        $wt_cfg_plugin[$wt_cpt]["section"]    = $wt_tmp[3];      
    }
}
$wt_cfg_item = array();
$wt_cfg_settings = array();

// perform auth
wt_auth();

$wt_error_occured = false;

// get the PHP version and redirect POST/GET variables
$wt_version = explode(".", phpversion());
if (intval($wt_version[0]) < 5 && intval($wt_version[1]) < 1) {
  $_POST   = $HTTP_POST_VARS;
  $_GET    = $HTTP_GET_VARS;
  $_SERVER = $HTTP_SERVER_VARS;
}
$PHP_SELF = $_SERVER["PHP_SELF"];

$wt_action  = wt_init_var('action');
$wt_section = wt_init_var('section');
$wt_pluginmenu = wt_init_var('menu');
$wt_plugincall = wt_init_var('plugin');
$wt_plugin  = "";
$wt_label   = "";
$wt_title   = "";

// Old style plugin
//for ($wt_cpt = 0; $wt_cpt < count($wt_cfg_plugin); $wt_cpt++) {
//	if ($wt_cfg_plugin[$wt_cpt]['section']==$wt_section) {	//styno
//        $wt_plugin = $wt_cfg_plugin[$wt_cpt]["plugin"];
//        $wt_label  = $wt_cfg_plugin[$wt_cpt]["label"];
//        $wt_title  = $wt_cfg_plugin[$wt_cpt]["title"];
//    }
//}

	
// if we want the config/about section...
if ($wt_section == "config") $wt_plugin = "config";
if ($wt_section == "about") $wt_plugin = "about";


header ("Expires: Mon, 01 Jul 1997 05:00:00 GMT");
header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
//header ("Cache-Control: no-cache, must-revalidate");
header ("Pragma: no-cache");

?>
<html>
<head>
  <meta http-equiv="pragma" content="no-cache">
  <title><?php echo $wt_cfg_prog; ?></title>
  <link rel="stylesheet" href="../styles.php">
</head>
<body>
	    <div id="admincontent">
            <?php
            if (isset($wt_plugincall)) {
            	//if (isset($Plugin)) {
            	//	echo time()."Plugin bestaat al";
            	//} else {
            	//	echo time()."Plugin bestaat nog niet";
            	//}
				// New style plugin
				$args = getArgs();
				include_once("../plugin/" . $wt_plugincall . ".wtp.php");
				// Create a new instance of the plugin
				$Plugin = new $wt_plugincall;
				// Initialize the plugin
				$Plugin->setBaseName($wt_plugincall);
				$Plugin->Plugin();

				if (isset($args['menu'])) {
					$Plugin->setCurrentMenu($args['menu']);
				} else {
					$Plugin->setCurrentMenu(0);
				}
				$Plugin->Prepare($wt_pluginmenu);
				//if (count($args) > 2) {
					$Plugin->Execute($args);
				//}
				//$Plugin->LoadMenu($wt_pluginmenu);

			} else if (!isset($wt_section)) {
				// Old style plugin
                // no section chosen; display homepage 
                echo "<center><br /><br /><br /><br /><br />$wt_cfg_prog<br /><br /><br /><br /><br /></center>";
            } else {
                // include wanted section
                $v = include($wt_plugins_dir . $wt_plugin . ".wt.php"); 
            }
            ?>
       </div>
</body>
</html>


<?php
function getArgs() {
	global $HTTP_POST_VARS, $HTTP_GET_VARS;
	if (count($_POST) > 0) {
		$args = $HTTP_POST_VARS;
	} else {
		$args = $_GET;
	}
	return $args;
}

?>