<?php
/*****************************************************************************
 * Web Tools (WT) - 0.2 - a collection of web hosting tools                  *
 * Copyright (C) 2000-2004 Colin Verot - colin@verot.net                     *
 * Copyright (C) 2005 Lambertus IJsselstein - webtools@lijsselstein.demon.nl *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify      *
 * it under the terms of the GNU General Public License as published by      *
 * the Free Software Foundation; either version 2 of the License, or         *
 * (at your option) any later version.                                       *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * General Public License for more details.                                  *
 *                                                                           *
 * You should have received a copy of the GNU General Public License         *
 * along with this program; if not, write to the                             *
 *    Free Software Foundation, Inc.                                         *
 *    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 *****************************************************************************/

require_once('config.inc.php');

if (intval(PHP_VERSION) > 3) {
	// Load the plugins
	$MenuItems = array();
	LoadPlugins("..\plugin");
} else {
	wt_error("Warning: This version of PHP does not support the new-style (wtp) plugins. At least PHP 4 is required.");
}
?>
<html>
<head>
  <meta http-equiv="pragma" content="no-cache">
  <title><?php echo $wt_cfg_prog; ?></title>
  <link rel="stylesheet" href="..\styles.php">
</head>
<body>
    <div id="adminframe">
        <div id="adminnav">
        	<h1>WebTools</h1>
            <hr />
            <div id="menu">
                <ul>
                <?php
                // New style plugins
                if (isset($MenuItems)) {
	                for ($i = 0; $i < count($MenuItems); $i++) {
	                	echo "<li><a href=\"main.php?plugin=" . $MenuItems[$i]['basename'] . "&menu=0\" target=\"main\" class=\"frame-button\">" . $MenuItems[$i]['name'] . "</a></li>";
	                }
	            }
                ?>
                <li><a href="main.php?section=config"  target="main">configuration</a></li>
                <li><a href="main.php?section=about" target="main">about</a></li></ul>
            </div>
            <hr />
            <p><?php echo $wt_cfg_prog; ?></b><br>&nbsp;v.&nbsp;<?php echo $wt_cfg_version; ?><br />
                <?php echo $wt_cfg_copyright; ?></p>
        </div>
       </div>
</body>
</html>

<?php
function LoadPlugins($dir) {
	global $Plugins, $MenuItems, $CurMenuItem, $MenuItemCount;
	$d = dir($dir);
	$i = 0;
	while (false !== ($entry = $d->read())) {
		if (is_dir($entry)) {
			// Recursively browse all (sub)directories
			//LoadPlugins($entry);		   		
		}
		else {
			$parts = split("\.", $entry);
			if ($parts[count($parts)-2] == "wtp") {
				$PluginName = $parts[0];
				// Include the plugin file into the project
				include_once($dir . "/" . $entry);
				// Create a new instance of the plugin
				$Plugin = new $PluginName;
				// Initialize the plugin
				$Plugin->setBaseName($PluginName);
				$Plugin->Plugin();
				$MenuItems[$i]['name'] = $Plugin->getName();
				$MenuItems[$i]['basename'] = $PluginName;
				$i++;
				unset($plugin);
			}
		}
	}
	$d->close();
}
?>